//----------------------------------------------------------------------------------
//
// CRUNGET : Get object
//
//----------------------------------------------------------------------------------
package Extensions
{
	import Actions.*;
	import flash.display.ActionScriptVersion;
	import flash.filters.ConvolutionFilter;
	
	import Conditions.*;
	
	import Expressions.*;
	
	import Objects.*;
	
	import RunLoop.*;
	
	import Services.*;
	
	import Sprites.*;

	public class CRunLOS extends CRunExtension
	{		
		
		public var map:Array;
		public var width:int;
		public var height:int;
		public var stepSize:int;
		public var tileSize:int;
		
		public function CRunFunction()
		{
			
		}

	    public override function getNumberOfConditions():int
	    {
	        return 1;
	    }

	    public override function condition(num:int, cnd:CCndExtension):Boolean
	    {
			switch(num)
			{
				case 0:
				{
					return isClear(cnd.getParamExpression(rh,0),cnd.getParamExpression(rh,1),cnd.getParamExpression(rh,2),cnd.getParamExpression(rh,3));
				}
			}
	        return false;
	    }
					
	    public override function action(num:int, act:CActExtension):void
	    {
			switch(num)
			{
				case 0:
				{
					newMap(act.getParamExpression(rh, 0), act.getParamExpression(rh, 1));
					break;
				}
				case 1:
				{
					setTileSize(act.getParamExpression(rh, 0));
					break;
				}
				case 2:
				{
					setStepSize(act.getParamExpression(rh, 0));
					break;
				}
				case 3:
				{
					setTile(act.getParamExpression(rh, 0),act.getParamExpression(rh, 1),act.getParamExpression(rh, 2));
					break;
				}
			}
	    }
	    
	    public override function expression(num:int):CValue
	    {
	    	return new CValue(0);
	    }
		
		public function newMap(x:int, y:int):void
		{
			map = new Array(x);
			for (var i:int = 0; i < x; i++)
			{
				map[i] = new Array(y);
				for (var a:int = 0; a < y; a++)
				{
					map[i][a] = false;
				}
			}
			width = x;
			height = y;
		}
		
		public function setTileSize(x:int):void
		{
			tileSize = x;
		}
		
		public function setStepSize(x:int):void
		{
			stepSize = x;
		}
		
		public function setTile(x:int, y:int, z:int):void
		{
			var clear:Boolean = (z != 0);
			map[x][y] = clear;
		}
		
		public function isClear(x1:int, y1:int, x2:int, y2:int):Boolean
		{
			if (x1<0||x1>tileSize*width||x2<0||x2>tileSize*width||y1<0||y1>tileSize*height||y2<0||y2>tileSize*height)
			{
				return false;
			}
			var length:Number = Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2));
			var steps:int = int(length / stepSize + 0.5);
			var xStep:Number = (x2 - x1) / steps;
			var yStep:Number = (y2 - y1) / steps;
			var curX:Number = x1;
			var curY:Number = y1;
			var tileX:int;
			var tileY:int;
			for (var i:int = 1; i <= steps; i++)
			{
				curX += xStep;
				curY += yStep;
				tileX = Math.min(Math.max(int(curX / tileSize), 0), width - 1);
				tileY = Math.min(Math.max(int(curY / tileSize), 0), height - 1);
				if (map[tileX][tileY])
				{
					return false;
				}
			}
			return true;
		}
	}
}